package org.gcube.portlets.user.tdcolumnoperation.client.rpc;


import java.util.List;

import org.gcube.portlets.user.tdcolumnoperation.shared.AggregationColumnSession;
import org.gcube.portlets.user.tdcolumnoperation.shared.OperationID;
import org.gcube.portlets.user.tdcolumnoperation.shared.SplitAndMergeColumnSession;
import org.gcube.portlets.user.tdcolumnoperation.shared.TdAggregateFunction;
import org.gcube.portlets.user.tdcolumnoperation.shared.TdOperatorComboOperator;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;

public interface TdColumnOperationServiceAsync
{

 
    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static TdColumnOperationServiceAsync instance;

        public static final TdColumnOperationServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (TdColumnOperationServiceAsync) GWT.create( TdColumnOperationService.class );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }

    public void loadOperatorForOperationId(OperationID operation, AsyncCallback<List<TdOperatorComboOperator>> callback);

	void startSplitAndMergeOperation(
			SplitAndMergeColumnSession operationColumnSession,
			AsyncCallback<Void> callback);

	void getListAggregationFunctionIds(
			AsyncCallback<List<TdAggregateFunction>> callback);

	void startGroupByOperation(AggregationColumnSession aggregationSession,
			AsyncCallback<Void> callback);




}
